import time

import sqlalchemy as sql
import matplotlib.pyplot as plt
import numpy as np

engine_fast = sql.create_engine('mysql+mysqldb://student:2021upol@158.194.88.42:16336/FAST')
conn_fast = engine_fast.connect()
metadata_fast = sql.MetaData()
TelescopeConditions = sql.Table('TelescopeConditions', metadata_fast, autoload=True, autoload_with=engine_fast)

id_shutterOpened = 11670
id_shutterClosed = 11899
pre_run = 100
time_interval = id_shutterClosed - id_shutterOpened + pre_run
sql_query = sql.select([TelescopeConditions]).where(TelescopeConditions.columns.id >= id_shutterOpened - pre_run)
ResultProxy = conn_fast.execute(sql_query)
rows_telecond = ResultProxy.fetchall()

timestamp_list = []
temp_list_outside = []
temp_list_camera = []
for row in rows_telecond:
    timestamp_list.append(time.ctime(row[1]))
    temp_list_outside.append(row[6])
    temp_list_camera.append(row[8])
print(timestamp_list[:5])

plt.scatter(timestamp_list[:time_interval], temp_list_outside[:time_interval],
            label="Outside temperature",
            color='green',
            marker='.',
            alpha=0.65)
plt.scatter(timestamp_list[:time_interval], temp_list_camera[:time_interval],
            label="Camera temperature",
            color='blue',
            marker='.',
            alpha=0.65)
plt.text(timestamp_list[pre_run + 1], temp_list_camera[pre_run + 1], " <- Shutter opened", size=10)
plt.xticks([0, pre_run, time_interval - 5], rotation=20)
plt.legend()
plt.xlabel("Date")
plt.ylabel("Temperature [C°]")
plt.title("Temperature difference during summer measurements")
plt.show()
